Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py	(revision 16150)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py	(revision 16151)
@@ -134,5 +134,5 @@
     'date_of_birth',
     'sex',
-    'nationality',
+    #'nationality',
     'entry_mode',
     'entry_session',
@@ -140,5 +140,5 @@
     'course_studied',
     'course_changed',
-    'change_level',
+    #'change_level',
     )
 
@@ -228,5 +228,5 @@
                 form_fields = form_fields.omit(field)
             form_fields['dispatch_address'].custom_widget = BytesDisplayWidget
-            form_fields['perm_address'].custom_widget = BytesDisplayWidget
+            #form_fields['perm_address'].custom_widget = BytesDisplayWidget
             return form_fields
         if self.target is not None and self.target == 'transshort':
@@ -235,5 +235,5 @@
                 form_fields = form_fields.omit(field)
             form_fields['dispatch_address'].custom_widget = BytesDisplayWidget
-            form_fields['perm_address'].custom_widget = BytesDisplayWidget
+            #form_fields['perm_address'].custom_widget = BytesDisplayWidget
             return form_fields
         if self.target == 'ictwk':
Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py	(revision 16150)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py	(revision 16151)
@@ -94,8 +94,26 @@
         return [item[0] for item in sorted_items]
 
+    def getToken(self, value):
+        return value
+
     def getTitle(self, value):
         return u"%s (₦ %s)" % (
             DESTINATION_COST[value][0],
             DESTINATION_COST[value][1])
+
+class OrderSource(BasicSourceFactory):
+    """
+    """
+    def getValues(self):
+        return ['o', 'c']
+
+    def getToken(self, value):
+        return value
+
+    def getTitle(self, value):
+        if value == 'o':
+            return _('Original')
+        if value == 'c':
+            return _('Certified True Copy')
 
 class IUnibenRegistration(IKofaObject):
@@ -248,15 +266,15 @@
 
     firstname = schema.TextLine(
-        title = _(u'First Name'),
+        title = _(u'First Name in School'),
         required = True,
         )
 
     middlename = schema.TextLine(
-        title = _(u'Middle Name'),
+        title = _(u'Middle Name in School'),
         required = False,
         )
 
     lastname = schema.TextLine(
-        title = _(u'Last Name (Surname)'),
+        title = _(u'Surname in School'),
         required = True,
         )
@@ -275,9 +293,9 @@
         )
 
-    nationality = schema.Choice(
-        vocabulary = nats_vocab,
-        title = _(u'Nationality'),
-        required = False,
-        )
+    #nationality = schema.Choice(
+    #    vocabulary = nats_vocab,
+    #    title = _(u'Nationality'),
+    #    required = False,
+    #    )
 
     email = schema.ASCIILine(
@@ -293,14 +311,70 @@
         )
 
-    perm_address = schema.Text(
-        title = _(u'Current Local Address'),
-        required = False,
-        readonly = False,
+    #perm_address = schema.Text(
+    #    title = _(u'Current Local Address'),
+    #    required = False,
+    #    readonly = False,
+    #    )
+
+    entry_session = schema.Choice(
+        title = _(u'Academic Session of Entry'),
+        source = academic_sessions_vocab,
+        required = False,
+        readonly = False,
+        )
+
+    end_session = schema.Choice(
+        title = _(u'Academic Session of Graduation'),
+        source = academic_sessions_vocab,
+        required = False,
+        readonly = False,
+        )
+
+    entry_mode = schema.Choice(
+        title = _(u'Mode of Entry'),
+        source = StudyModeSource(),
+        required = False,
+        readonly = False,
+        )
+
+    course_studied = schema.Choice(
+        title = _(u'Course of Study'),
+        source = CertificateSource(),
+        required = False,
+        readonly = False,
+        )
+
+    course_changed = schema.Choice(
+        title = _(u'Change of Study Course / Transfer'),
+        description = u'If yes, select previous course of study.',
+        source = CertificateSource(),
+        readonly = False,
+        required = False,
+        )
+
+    #change_level = schema.Choice(
+    #    title = _(u'Change Level'),
+    #    description = u'If yes, select level at which you changed course of study.',
+    #    source = StudyLevelSource(),
+    #    required = False,
+    #    readonly = False,
+    #    )
+
+    purpose = schema.TextLine(
+        title = _(u'Transcript Purpose'),
+        required = False,
+        )
+
+    order = schema.Choice(
+        source = OrderSource(),
+        title = _(u'Type of Order'),
+        required = False,
         )
 
     dispatch_address = schema.Text(
-        title = _(u'Dispatch Addresses'),
-        description = u'Addresses to which transcripts should be posted. '
-                       'Addresses must involve same courier charges.',
+        title = _(u'Recipient Body'),
+        description = u'Addresses (including email address and phone number) '
+                       'to which transcripts should be posted. '
+                       'All addresses must involve same courier charges.',
         required = False,
         readonly = False,
@@ -311,48 +385,4 @@
         source = DestinationCostSource(),
         required = True,
-        )
-
-    entry_mode = schema.Choice(
-        title = _(u'Entry Mode'),
-        source = StudyModeSource(),
-        required = False,
-        readonly = False,
-        )
-
-    entry_session = schema.Choice(
-        title = _(u'Entry Session'),
-        source = academic_sessions_vocab,
-        required = False,
-        readonly = False,
-        )
-
-    end_session = schema.Choice(
-        title = _(u'End Session'),
-        source = academic_sessions_vocab,
-        required = False,
-        readonly = False,
-        )
-
-    course_studied = schema.Choice(
-        title = _(u'Course of Study / Degree'),
-        source = CertificateSource(),
-        required = False,
-        readonly = False,
-        )
-
-    course_changed = schema.Choice(
-        title = _(u'Change of Study Course'),
-        description = u'If yes, select previous course of study.',
-        source = CertificateSource(),
-        readonly = False,
-        required = False,
-        )
-
-    change_level = schema.Choice(
-        title = _(u'Change Level'),
-        description = u'If yes, select level at which you changed course of study.',
-        source = StudyLevelSource(),
-        required = False,
-        readonly = False,
         )
 
Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests/test_browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests/test_browser.py	(revision 16150)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests/test_browser.py	(revision 16151)
@@ -27,5 +27,4 @@
 from zope.securitypolicy.interfaces import IPrincipalRoleManager
 from zope.component import createObject, getUtility
-from waeup.kofa.configuration import SessionConfiguration
 from waeup.kofa.interfaces import IUserAccount
 from waeup.kofa.browser.tests.test_pdf import samples_dir
@@ -296,5 +295,5 @@
 
     def test_transcript_payment(self):
-        configuration = SessionConfiguration()
+        configuration = CustomSessionConfiguration()
         configuration.academic_session = session_1
         self.app['configuration'].addSessionConfiguration(configuration)
@@ -302,7 +301,7 @@
         applicantscontainer = ApplicantsContainer()
         applicantscontainer.year = session_1
-        applicantscontainer.application_fee = 200.0
+        applicantscontainer.application_fee = 1.0 # Must be set but is not used.
         applicantscontainer.code = u'trans1234'
-        applicantscontainer.prefix = 'trans'
+        applicantscontainer.prefix = 'transfull'
         applicantscontainer.title = u'This is a trans container'
         applicantscontainer.application_category = 'no'
@@ -332,14 +331,11 @@
         self.browser.getControl(name="form.date_of_birth").value = '09/09/1988'
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
-        self.browser.getControl(name="form.nationality").value = ['NG']
         self.browser.getControl(name="form.firstname").value = 'Angela'
         self.browser.getControl(name="form.lastname").value = 'Merkel'
         self.browser.getControl(name="form.sex").value = ['f']
-        self.browser.getControl(name="form.no_copies").value = ['3']
+        self.browser.getControl(name="form.no_copies").value = ['2']
         self.browser.getControl(name="form.course_studied").value = ['CERT1']
         self.browser.getControl(name="form.matric_number").value = '234'
-        self.browser.getControl(name="form.place_of_birth").value = 'Bochum'
         self.browser.getControl(name="form.dispatch_address").value = 'Kuensche'
-        self.browser.getControl(name="form.perm_address").value = 'Kuensche'
         self.browser.getControl(name="form.entry_mode").value = ['ug_ft']
         self.browser.getControl(name="form.entry_session").value = ['2014']
@@ -347,8 +343,9 @@
         self.browser.getControl(name="form.phone.country").value = ['+234']
         self.browser.getControl(name="form.phone.ext").value = '5678'
+        self.browser.getControl(name="form.charge").value = ['nigeria']
         self.browser.getControl("Save").click()
         self.browser.getControl("Add online payment ticket").click()
         self.assertTrue('Payment ticket created' in self.browser.contents)
-        self.assertTrue('<span>200.0</span>' in self.browser.contents)
-        self.assertEqual(applicant.values()[0].amount_auth, 200.0)
+        self.assertTrue('<span>40000.0</span>' in self.browser.contents)
+        self.assertEqual(applicant.values()[0].amount_auth, 40000.0)
         return