Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py	(revision 16160)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py	(revision 16163)
@@ -257,25 +257,24 @@
     def post_text(self):
         return """
-Please note that at the point of registration for your programme of study (course), you will be required to present the following documents: Current UTME result slip, WAEC/NECO (0' Level) result, birth certificate or sworn affidavit of age, and health certificate from a recognized medical centre.
-
-All credentials (original) will be checked during registration. This admission will be cancelled at any point in time it is found that your claims in the application form are false.
-
-You are required to show evidence of the result/credentials you presented on application for admission.
+Please note that at the point of registration for your programme of study (course), you will be required to present the following documents: Current UTME result slip, WAEC/NECO (0' Level) result, Birth certificate or sworn affidavit of age, and Health certificate from a recognized Medical Centre.
+
+All credentials (orlginal) will be checked during registration. This admission will be cancelled at any point in time it is found that your claims in the application form are false.
+
+You are required to show evidence of the result / credentials you presented on application for admission.
 
 Fees can be paid using any of the following options:
 
-1. Fees can be paid on through you portal page. Download the pdf document <link href='https://iuokada.waeup.org/documents/IUOAL/file.pdf'><strong>Fee Structure and Fees Payment Procedure</strong></link> for the options you have to make your payment, as well as instructions on how to use your preferred payment option.
-2. If you choose to use the bank payment option, you can pay at any branch of the following banks through etranzact platform only: Access Bank, First Bank, Zenith Bank, and Keystone Bank.
+Fees can be paid through your portal page. INSTRUCTIONS can be found below "FEES PAYMENT PROCEDURE" for the options you have to make your payment, as well as instructions on how to use your preferred payment option. If you choose to use the bank payment option, you can pay at any branch of the following banks through Etranzact platform only: Access Bank, First Bank, Zenith Bank
 
 Kindly note the following:
 
-1. Fees indicated on the fee structure page are valid for the current session only.
-2. Your Student Id (indicated above) is your login to the university portal.
-3. As an indication of your acceptance of this offer of admission, you should pay a non-refundable acceptance deposit of N200,000. Further note that the N200,000 deposit is part of the tuition fee for the session. Failure to pay after the expiration of two weeks may lead to forfeiture of admission.
-4. All fees must be paid in full at the beginning of the session, as basis for accommodation, registration and attendance of lectures. This is the rule for all students at all levels. Installmental payments of not more than two installments may be allowed under exceptional circumstances.
-5. Fees once paid are not refundable.
-6. It is advisable that you keep the original receipts of fees paid and present them on demand.
-
-Accommodation: Accommodation in university hostels is compulsory for every student. No student is allowed to live outside the hostels. Any student who does so will be expelled from the university. For further details, please refer to the bursary for information on fees.
+Fees indicated on the Fee Structure page are valid for the current session only.
+Your Student Id (indicated above) Is your logln to the University portal.
+As an indication of your acceptance of this offer of admission, you should pay a non-refundable Acceptance deposit of 200,000. Further note that the 200,000 deposit is part of the tuition fee for the session. Failure to pay after the expiration of two weeks may lead to forfeiture of admission.
+All fees must be paid in full at the beginning of the session, as basis for accommodation, registration and attendance of lectures. This is the rule for all students at all levels. Install mental payments of not more than two installments, may be allowed under exceptional circumstances.
+Fees once paid are not refundable.
+It is advisable that you keep the original receipts of fees paid and present them on demand.
+
+Accommodation: Accommodation in University hostels is compulsory for every student. No student Is allowed to live outside the hostels. Any student who does so will be expelled from the University.
 
 Food: Food is available in cafeteria on "pay-as-you-eat" basis.
@@ -283,7 +282,7 @@
 Resumption Date: The University opens for fresh students on Saturday, 28th September, 2020. All newly admitted students are expected to report on that date.
 
-Registration/Orientation Programme: Orientation programme/registration for fresh students will start on Monday, 30th September 2020. Registration ends on 30th October. A late registration fee of N50,000 will be charged after this date. All credentials, O'Level Results, Birth Certificate/Age Declaration, UTME Result Slip (original) will be checked during registration. This admission will be cancelled at any point in time if it is found that any of your claims in the application form is false.
-
-Transport Facility: The university provides a compulsory shuttle bus service to all students at a fee already included in the other charges.
+Registration/Orientation Programme: Orientation programme/registration for fresh students will start on Monday, 30th September 2020. Registration ends on 2020-10-30. A late registration fee of N50,000 will be charged after this date. All credentials, O'Level Results, Birth Certificate/Age? Declaration, UTME Result Slip (Original) will be checked during registration. This admission will be cancelled at any point in time it is found that any of your claims in the application form is false.
+
+Transport Facility: The University provides a compulsory shuttle bus service to all students at a fee already included in the other charges.
 
 Kindly note that fresh students are not allowed the use of private vehicles.
@@ -291,12 +290,12 @@
 Conduct: All students are expected to conduct themselves properly and dress decently on campus, as well as obey all rules and regulations as failure to comply will attract appropriate sanctions.
 
-We wish you a successful academic career In Igbinedion University.
+We wish you a successful academic career In lgbinedion University.
 
 Congratulations!
 
-L.P.E. Jagbedia
-Ag. Registrar
-registrar@iuokada.edo.ng
-08037349527
+Friday Benji Bakare Esq.
+Registrar
+registrar@iuokada.edu.ng
+08035902949
 """
 
@@ -312,5 +311,5 @@
         return students_utils.renderPDFAdmissionLetter(self,
             self.context.student, omit_fields=self.omit_fields,
-            pre_text=self.pre_text, post_text=self.post_text,
-            mergefiles=mergefiles,
-            watermark=watermark)
+            pre_text=self.pre_text, post_text=self.post_text)
+            #mergefiles=mergefiles,
+            #watermark=watermark)