Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py	(revision 16183)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py	(revision 16184)
@@ -623,10 +623,17 @@
     @property
     def form_fields(self):
-        if self.target == 'ictwk':
+        if self.target is not None and self.target == 'tscf':
+            form_fields = grok.AutoFields(ITranscriptApplicant)
+            for field in TRANS_OMIT_FIELDS:
+                form_fields = form_fields.omit(field)
+        elif self.target is not None and self.target == 'tscs':
+            form_fields = grok.AutoFields(ITranscriptApplicant)
+            for field in TRANS_SHORT_OMIT_FIELDS:
+                form_fields = form_fields.omit(field)
+        elif self.target is not None and self.target == 'ictwk':
             form_fields = grok.AutoFields(IUnibenRegistration)
             for field in REGISTRATION_OMIT_PDF_FIELDS:
                 form_fields = form_fields.omit(field)
-            return form_fields
-        if self.target is not None and self.target.startswith('pg'):
+        elif self.target is not None and self.target.startswith('pg'):
             form_fields = grok.AutoFields(ICustomPGApplicant)
             for field in PG_OMIT_PDF_FIELDS:
Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests/test_browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests/test_browser.py	(revision 16183)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/tests/test_browser.py	(revision 16184)
@@ -174,5 +174,4 @@
 
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
-        self.slip_path = self.view_path + '/application_slip.pdf'
         self.browser.open(self.manage_path)
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
@@ -294,5 +293,5 @@
         print "Sample ictwk_application_slip.pdf written to %s" % path
 
-    def test_transcript_payment(self):
+    def test_transcript_application(self):
         configuration = CustomSessionConfiguration()
         configuration.academic_session = session_1
@@ -308,5 +307,5 @@
         applicantscontainer.mode = 'create'
         applicantscontainer.strict_deadline = True
-        applicantscontainer.with_picture = False
+        applicantscontainer.with_picture = True
         delta = datetime.timedelta(days=10)
         applicantscontainer.startdate = datetime.datetime.now(pytz.utc) - delta
@@ -337,5 +336,5 @@
         self.browser.getControl(name="form.course_studied").value = ['CERT1']
         self.browser.getControl(name="form.matric_number").value = '234'
-        self.browser.getControl(name="form.dispatch_address").value = 'Kuensche'
+        self.browser.getControl(name="form.dispatch_address").value = 'Kuensche\nMarsch 5'
         self.browser.getControl(name="form.entry_mode").value = ['ug_ft']
         self.browser.getControl(name="form.entry_session").value = ['2014']
@@ -344,4 +343,8 @@
         self.browser.getControl(name="form.phone.ext").value = '5678'
         self.browser.getControl(name="form.charge").value = ['nigeria']
+        image = open(SAMPLE_IMAGE, 'rb')
+        ctrl = self.browser.getControl(name='form.passport')
+        file_ctrl = ctrl.mech_control
+        file_ctrl.add_file(image, filename='myphoto.jpg')
         self.browser.getControl("Save").click()
         self.browser.getControl("Add online payment ticket").click()
@@ -349,3 +352,12 @@
         self.assertTrue('<span>40000.0</span>' in self.browser.contents)
         self.assertEqual(applicant.values()[0].amount_auth, 40000.0)
+        IWorkflowState(applicant).setState('submitted')
+        self.browser.getLink("My Data").click()
+        self.browser.getLink("Download application slip").click()
+        self.assertEqual(self.browser.headers['Status'], '200 Ok')
+        self.assertEqual(self.browser.headers['Content-Type'],
+                         'application/pdf')
+        path = os.path.join(samples_dir(), 'tscf_application_slip.pdf')
+        open(path, 'wb').write(self.browser.contents)
+        print "Sample tscf_application_slip.pdf written to %s" % path
         return