Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_webservices.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_webservices.py	(revision 16191)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_webservices.py	(revision 16192)
@@ -839,5 +839,8 @@
                 'amount_auth': 12.12, 'p_session': 2012,
                 'p_state': 'failed',
-                'r_company': 'xyz'}
+                'r_company': 'xyz',
+                'fullname': 'Anna Tester',
+                'id': 'K1000000',
+                'matric_number': '234'}
                 ])
         results = server.get_unpaid_payments(4)
@@ -850,5 +853,8 @@
                   'p_session': 2012,
                   'p_state': 'unpaid',
-                  'r_company': None},
+                  'r_company': None,
+                  'fullname': 'Anna Tester',
+                  'id': 'K1000000',
+                  'matric_number': '234'},
                 {'display_item': None,
                   'p_id': '%s' % p_id_1,
@@ -857,5 +863,8 @@
                   'p_session': 2012,
                   'p_state': 'failed',
-                  'r_company': 'xyz'}
+                  'r_company': 'xyz',
+                  'fullname': 'Anna Tester',
+                  'id': 'K1000000',
+                  'matric_number': '234'},
                 ])
         results = server.get_unpaid_payments(4,'xyz')
@@ -868,5 +877,8 @@
                   'p_session': 2012,
                   'p_state': 'failed',
-                  'r_company': 'xyz'},
+                  'r_company': 'xyz',
+                  'fullname': 'Anna Tester',
+                  'id': 'K1000000',
+                  'matric_number': '234'},
                 ])
 
@@ -892,4 +904,8 @@
 <value><nil/></value></member>
 <member>
+<name>amount_auth</name>
+<value><double>12.12</double></value>
+</member>
+<member>
 <name>p_id</name>
 <value><string>%s</string></value>
@@ -900,10 +916,18 @@
 </member>
 <member>
+<name>matric_number</name>
+<value><string>234</string></value>
+</member>
+<member>
 <name>p_category</name>
 <value><string>schoolfee</string></value>
 </member>
 <member>
-<name>amount_auth</name>
-<value><double>12.12</double></value>
+<name>fullname</name>
+<value><string>Anna Tester</string></value>
+</member>
+<member>
+<name>p_state</name>
+<value><string>failed</string></value>
 </member>
 <member>
@@ -912,6 +936,6 @@
 </member>
 <member>
-<name>p_state</name>
-<value><string>failed</string></value>
+<name>id</name>
+<value><string>K1000000</string></value>
 </member>
 </struct></value>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/webservices.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/webservices.py	(revision 16191)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/webservices.py	(revision 16192)
@@ -26,4 +26,5 @@
     IUniversity, IExtFileStore, IFileStoreNameChooser, IKofaUtils,
     GRADUATED, TRANSREL)
+from waeup.kofa.payments.interfaces import IPayer
 from waeup.kofa.utils.helpers import get_fileformat, to_timezone
 from waeup.kofa.students.catalog import StudentsQuery
@@ -446,5 +447,8 @@
                         p_session=payment.p_session,
                         p_state=payment.p_state,
-                        r_company=getattr(payment, 'r_company', None)
+                        r_company=getattr(payment, 'r_company', None),
+                        id = IPayer(payment).id,
+                        matric_number = IPayer(payment).matric_number,
+                        fullname = IPayer(payment).display_fullname,
                         )
                       )
@@ -458,5 +462,8 @@
                 p_session=payment.p_session,
                 p_state=payment.p_state,
-                r_company=getattr(payment, 'r_company', None)
+                r_company=getattr(payment, 'r_company', None),
+                id = IPayer(payment).id,
+                matric_number = IPayer(payment).matric_number,
+                fullname = IPayer(payment).display_fullname,
                 )
               )