Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/export.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/export.py	(revision 16194)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/export.py	(revision 16195)
@@ -32,5 +32,6 @@
     CourseTicketExporter,
     StudentPaymentExporter,
-    DataForBursaryExporter)
+    DataForBursaryExporter,
+    TrimmedDataExporter)
 from waeup.kofa.utils.helpers import iface_names
 from kofacustom.nigeria.interfaces import MessageFactory as _
@@ -50,4 +51,43 @@
         return super(
             NigeriaStudentExporter, self).mangle_value(
+            value, name, context=context)
+
+class NigeriaTrimmedDataExporter(TrimmedDataExporter):
+    """The Student Trimmed Data Exporter first filters the set of students
+    by searching the students catalog. Then it exports a trimmed data set
+    of this set of students.
+    """
+
+    fields = (
+        'student_id',
+        'matric_number',
+        'reg_number',
+        'firstname',
+        'middlename',
+        'lastname',
+        'sex',
+        'email',
+        'phone',
+        'nationality',
+        'date_of_birth',
+        'state',
+        'current_mode',
+        'certcode',
+        'faccode',
+        'depcode',
+        'current_level',
+        'current_session',
+        'current_verdict',
+        'entry_session',
+        'lg_state',
+        'lg_area')
+
+    def mangle_value(self, value, name, context=None):
+        if name == 'lg_state':
+            value = context.lga.split('_')[0]
+        if name == 'lg_area':
+            value = '-'.join(context.lga.split('_')[1:])
+        return super(
+            NigeriaTrimmedDataExporter, self).mangle_value(
             value, name, context=context)
 
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py	(revision 16194)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py	(revision 16195)
@@ -26,5 +26,6 @@
 from kofacustom.nigeria.students.export import (
     NigeriaStudentExporter, NigeriaStudentPaymentExporter,
-    ClearanceRequestedStudentExporter, NigeriaDataForBursaryExporter)
+    ClearanceRequestedStudentExporter, NigeriaDataForBursaryExporter,
+    NigeriaTrimmedDataExporter)
 from kofacustom.nigeria.testing import FunctionalLayer
 
@@ -200,2 +201,37 @@
             )
         return
+
+class NigeriaStudentTrimmedDataExporterTest(StudentImportExportSetup):
+
+    layer = FunctionalLayer
+
+    std_csv_entry = (
+        'my adm code,my clr code,1981-02-04#,anna@sample.com,,'
+        'Anna,,Tester,234,M.,NG,,,"Studentroad 21\nLagos 123456\n",,'
+        '+234-123-12345#,123,f,A111111,0,,,created'
+        )
+
+    def setUp(self):
+        super(NigeriaStudentTrimmedDataExporterTest, self).setUp()
+        self.setup_for_export()
+        self.student.lga = 'abia_aba_north'
+        return
+
+    def test_export_all(self):
+        # we can really export students
+        # set values we can expect in export file
+        self.setup_student(self.student)
+        exporter = NigeriaTrimmedDataExporter()
+        exporter.export_all(self.app, self.outfile)
+        result = open(self.outfile, 'rb').read()
+        self.assertTrue(
+            'student_id,matric_number,reg_number,firstname,middlename,'
+            'lastname,sex,email,phone,nationality,date_of_birth,state,'
+            'current_mode,certcode,faccode,depcode,current_level,'
+            'current_session,current_verdict,entry_session,lg_state,lg_area\r\n'
+            'A111111,234,123,Anna,M.,Tester,f,anna@sample.com,+234-123-12345#,'
+            'NG,1981-02-04#,created,ug_ft,CERT1,NA,NA,200,2012,0,2010,'
+            'abia,aba-north'
+            in result
+            )
+        return